/* SpringMass - Decompiled by JODE
 * Visit http://jode.sourceforge.net/
 */
import com.cycling74.max.Executable;
import com.cycling74.max.MaxClock;
import com.cycling74.max.MaxObject;

public class SpringMass extends MaxObject implements Executable
{
    private float K = 0.1F;
    private float position = 0.0F;
    private float damping = 0.99F;
    private float interval = 10.0F;
    private float acceleration = 0.0F;
    private float velocity = 0.0F;
    private MaxClock clock;
    
    public SpringMass() {
	declareAttribute("K");
	declareAttribute("position");
	declareAttribute("damping");
	declareAttribute("interval");
	declareIO(1, 3);
	clock = new MaxClock(this);
    }
    
    public void inlet(int i) {
	if (i == 1)
	    clock.delay(0.0);
	else
	    clock.unset();
    }
    
    public void execute() {
	bang();
	clock.delay((double) interval);
    }
    
    public void bang() {
	acceleration = -position * K;
	velocity += acceleration;
	velocity = velocity * damping;
	position += velocity;
	outlet(0, position);
	outlet(1, velocity);
	outlet(2, acceleration);
    }
    
    public void reset() {
	position = 0.0F;
	acceleration = 0.0F;
	velocity = 0.0F;
    }
    
    protected void notifyDeleted() {
	clock.unset();
    }
}

